const {app, BrowserWindow, ipcMain} = require('electron');
const path = require('path');
const url = require('url');

let mainWindow;

function createWindow(){
  mainWindow = new BrowserWindow({
    width: 800,
    height: 600,
    webPreferences: {
      nodeIntegration: true
    }
  });
  mainWindow.loadURL(url.format({
    pathname: path.join(__dirname, 'view/index.html'),
    protocol: 'file',
    slashes: true
  }));

  mainWindow.webContents.openDevTools();
  mainWindow.on('closed', ()=>{mainWindow = null;})
}


app.on('ready', createWindow);
app.on('window-all-closed', ()=>{
  if (process.platform !== 'darwin')
    app.quit();
});

app.on('activate', ()=> {
  if (mainWindow === null){
    createWindow();
  }
});

ipcMain.on("getPath", (event, arg) => {
  let val = null;
  switch(arg.toLowerCase()){
    case "app":
      val = app.getAppPath(); break;
    case "home":
      val = app.getPath('home'); break;
    case "user":
      val = app.getPath('user'); break;
  }

  event.returnValue = val;
});

